﻿
#include <atlstr.h>
#include <atlconv.h>
#include <atlbase.h>
#include <atlsafe.h>

#import "..\\CsClassLibrary\\bin\\Debug\\CsClassLibrary.tlb" no_namespace named_guids

inline SAFEARRAY* GetFoo(IDevice *pDevice) {
	SAFEARRAY* _result = 0;
	_com_dispatch_method(pDevice, 0x60020000, DISPATCH_METHOD, VT_ARRAY | VT_UI4, (void*)&_result, NULL);
	return _result;
}

inline HRESULT GetFoo2(IDevice* pDevice, SAFEARRAY** result) {
	return _com_dispatch_method(pDevice, 0x60020001, DISPATCH_METHOD, VT_EMPTY, NULL, 
		L"\x6013", result);
}

int main()
{
	CoInitialize(NULL);

	IDevice* mp_device;
	HRESULT hr = CoCreateInstance(CLSID_CDevice, NULL, CLSCTX_INPROC_SERVER, DIID_IDevice, reinterpret_cast<void**>(&mp_device));
	if (hr == S_OK)
	{
		{
			// 배열이 아닌 VT_UI4의 경우에는 #import로 자동생성된 코드를 사용해도 정상적으로 호출
			unsigned long nResult = 0;

			mp_device->GetFoo3(&nResult);
			nResult = mp_device->GetFoo4();
		}

		// 하지만~~~~~~~~~~~~ 배열 + VT_UI4의 경우에는 자동생성된 코드를 사용하면 crash~~~~~~~~~

		// SAFEARRAY* presult2 = mp_device->GetFoo();
		SAFEARRAY* presult = GetFoo(mp_device);

		SAFEARRAY *pArrayResult = nullptr;
		// mp_device->GetFoo2(&pArrayResult);
		GetFoo2(mp_device, &pArrayResult);

		{
			DISPID dispId;
			LPOLESTR lpDesc = (LPOLESTR)L"GetFoo";
			HRESULT hr = mp_device->GetIDsOfNames(IID_NULL, &lpDesc, 1, 0, &dispId);
			
			CComVariant varResult;
			DISPPARAMS params = { nullptr, nullptr, 0, 0 };
			hr = mp_device->Invoke(dispId, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &params, &varResult, nullptr, nullptr);
			if (hr != S_OK)
			{
				throw 1;
			}
		}


		{
			DISPID dispId;
			LPOLESTR lpDesc = (LPOLESTR)L"GetFoo2";
			HRESULT hr = mp_device->GetIDsOfNames(IID_NULL, &lpDesc, 1, 0, &dispId);

			CComVariant* varParams = new CComVariant[1];

			SAFEARRAY* pArray = nullptr;
			varParams[0].pparray = &pArray;
			varParams[0].vt = VT_ARRAY | VT_BYREF | VT_UI4;
			DISPPARAMS params = { varParams, nullptr, 1, 0 };

			hr = mp_device->Invoke(dispId, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &params, nullptr, nullptr, nullptr);
			if (hr != S_OK)
			{
				throw 1;
			}
		}


		{
			// https://learn.microsoft.com/en-us/answers/questions/209566/com-interop-pass-an-in-out-array.html

			DISPID dispId;
			LPOLESTR lpDesc = (LPOLESTR)L"GetFoo2";
			HRESULT hr = mp_device->GetIDsOfNames(IID_NULL, &lpDesc, 1, 0, &dispId);

			DISPPARAMS params = { nullptr, nullptr, 0, 0 };
			VARIANT vByteArray, vResult;

			VariantInit(&vByteArray);
			VariantInit(&vResult);

			 SAFEARRAY* pByteArray = nullptr;
			 V_VT(&vByteArray) = VT_ARRAY | VT_BYREF | VT_UI4;
			 V_ARRAYREF(&vByteArray) = &pByteArray;

			params.rgvarg = &vByteArray;
			params.cArgs = 1;

			hr = mp_device->Invoke(dispId, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &params, nullptr, nullptr, nullptr);
			if (hr != S_OK)
			{
				throw 1;
			}
		}

		mp_device->Release();
	}

	CoUninitialize();
}
